#ifndef EWNUM_HH
#define EWNUM_HH

namespace WNum{
  namespace GLOBAL{
    enum {
      RUNNUM = 1, //1
      EVENTNUM,   //2
      TRIGGERBIT  //3
    };
  }

  namespace RAWDATA{
    enum {
      DEVICE = 1, // 1
      FPL,        // 2
      DETECTOR,   // 3
      MODULE,     // 4
      GEO,        // 5
      CHANNEL,    // 6
      VALUE       // 7
    };
  }

  namespace BIGRIPS{
    enum {
      F3PPAC1A_X = 1, // 1
      F3PPAC1A_Y,     // 2
      F3PPAC1B_X,     // 3
      F3PPAC1B_Y,     // 4
      F3PPAC2A_X,     // 5
      F3PPAC2A_Y,     // 6
      F3PPAC2B_X,     // 7
      F3PPAC2B_Y,     // 8
      F3X,            // 9
      F3A,            //10 
      F3Y,            //11
      F3B,            //12
      F3PLA_TL,       //13
      F3PLA_TR,       //14
      F3PLA_QL,       //15
      F3PLA_QR,       //16
      F5PPAC1A_X,     //17
      F5PPAC1A_Y,     //18
      F5PPAC1B_X,     //19
      F5PPAC1B_Y,     //20
      F5PPAC2A_X,     //21
      F5PPAC2A_Y,     //22
      F5PPAC2B_X,     //23
      F5PPAC2B_Y,     //24
      F5X,            //25
      F5A,            //26
      F5Y,            //27
      F5B,            //28
      F7PPAC1A_X,     //29
      F7PPAC1A_Y,     //30
      F7PPAC1B_X,     //31
      F7PPAC1B_Y,     //32
      F7PPAC2A_X,     //33
      F7PPAC2A_Y,     //34
      F7PPAC2B_X,     //35
      F7PPAC2B_Y,     //36
      F7X,            //37
      F7A,            //38
      F7Y,            //39
      F7B,            //40
      F7PLA_TL,       //41
      F7PLA_TR,       //42
      F7PLA_QL,       //43
      F7PLA_QR,       //44
      F7ICQ           //45, id 1-6
    };
  }

  namespace ZERODEGREE{
    enum {
      F8PPAC1A_X = 1, // 1
      F8PPAC1A_Y,     // 2
      F8PPAC1B_X,     // 3
      F8PPAC1B_Y,     // 4
      F8PPAC2A_X,     // 5
      F8PPAC2A_Y,     // 6
      F8PPAC2B_X,     // 7
      F8PPAC2B_Y,     // 8
      F8X,            // 9
      F8A,            //10 
      F8Y,            //11
      F8B,            //12
      F9PPAC1A_X,     //13
      F9PPAC1A_Y,     //14
      F9PPAC1B_X,     //15
      F9PPAC1B_Y,     //16
      F9PPAC2A_X,     //17
      F9PPAC2A_Y,     //18
      F9PPAC2B_X,     //19
      F9PPAC2B_Y,     //20
      F9X,            //21
      F9A,            //22
      F9Y,            //23
      F9B,            //24
      F11PPAC1A_X,     //25
      F11PPAC1A_Y,     //26
      F11PPAC1B_X,     //27
      F11PPAC1B_Y,     //28
      F11PPAC2A_X,     //29
      F11PPAC2A_Y,     //30
      F11PPAC2B_X,     //31
      F11PPAC2B_Y,     //32
      F11X,            //33
      F11A,            //34
      F11Y,            //35
      F11B,            //36
      F11ICQ           //37, id 1-8
    };
  }

  namespace SAMURAIDC{
    enum {
      ID=1,// 1:BPC, 2:BDC1, 3:BDC2, 4:FDC1, 5:FDC2 11-:IDPlane (11,12:BPC  21-28:BDC1  31-38:BDC2  41-54:FDC1  61-74:FDC2)
      XPos=10,   // for ID=1-5
      XAng=11,
      YPos=12,
      YAng=13,
      Chi2=14,
      NTr=15,
      WIREID=51, // for ID=11-
      TRaw=52,   // 
      TCal=53,   // 
      SBVX=101,   // for ID=10
      SBVY=102,   // 
      TGTX=103,   // 
      TGTY=104,   // 

    };
  }

  namespace SAMURAIPLA{
    enum {
      // id: 1=F3pl, 2=F3pl-40nsec, 3=F7pl, 4=F13pl-1, 5=F13pl-2, 6=SBV
      ID = 1,     //1

      QLRaw = 10, //10
      QRRaw,      //11
      QAveRaw,    //12
      LogQRaw,    //13

      TLRaw = 30, //30
      TRRaw,      //31
      TAveRaw,    //32
      DTRaw,      //33
      TAveCal,    //34

      // id: 0
      TOF1313 = 50, //50
    };
  }

  namespace SAMURAIHOD{
    enum {
      ID=1,     //1
      CHANNEL,  //2
      CHHIT,    //3
      QURaw=10, //10
      QDRaw,    //11
      QAveRaw,  //12
      QUPed,    //13
      QDPed,    //14
      QAvePed,  //15
      QUCal,    //16
      QDCal,    //17
      QAveCal,  //18

      TURaw=20, //20
      TDRaw,    //21
      Time,     //22

      HODQMAXCH=30,//30
      HODQMAX,     //31
      HODQMAXTDC, //32
    };
  }

  namespace DALI{
    enum {
      // id = 1, 142
      ID=1,     //1
      Layer,    //2
      Theta,    //3
      CosTheta, //4

      RawADC=10,      //10
      Energy,         //11
      DoppCorEnergy,  //12

      RawTDC=30,    //30
      Time,         //31
      TimeOffseted, //32

      TimeTrueEnergy=40,      //40
      TimeTrueDoppCorEnergy,  //41
      TimeTrueTimeOffseted,   //42
      TimeTrueTime,           //43

    };
  }

  namespace NEBULA{
    enum {
      // id = 1, 144
      ID=1,     //1
      Layer,    //2
      SubLayer, //3
      DetPosX,  //4
      DetPosY,  //5
      DetPosZ,  //6
      Hit,      //7

      QURaw=10,     //10
      QDRaw,        //11
      QUPed,        //12
      QDPed,        //13
      QUCal,        //14
      QDCal,        //15
      QAvePed,      //16
      QAveCal,      //17
      LogQPed,      //18
      LogQCal,      //19
      IvSqrtQUPed,  //20
      IvSqrtQDPed,  //21
      IvSqrtQAvePed,//22

      TURaw=30, //30
      TDRaw,    //31
      TUCal,    //32
      TDCal,    //33
      TUSlw,    //34
      TDSlw,    //35
      DTRaw,    //36
      DTCal,    //37
      DTSlw,    //38
      TAveRaw,  //39
      TAveCal,  //40
      TAveSlw,  //41
      TTOFGamma,   //42
      TTOFNeutron, //43

      PosCal=50,//50
      PosSlw,   //51

      PosX=60,      //60
      PosY,         //61
      PosZ,         //62
      FlightLength, //63

      // id = 0
      Multiplicity_N   = 100,  //100
      Multiplicity_N1,         //101
      Multiplicity_N2,         //102
      Multiplicity_V1,         //103
      Multiplicity_V2,         //104
      Multiplicity_N11 = 111,  //111
      Multiplicity_N12,        //112
      Multiplicity_N21 = 121,  //121
      Multiplicity_N22,        //122
    };
  }

  namespace NEBULAHPC{
    enum {
      ID=1,     //1
      Layer,    //2
      SubLayer, //3
      DetPosX,  //4
      DetPosY,  //5
      DetPosZ,  //6

      TRaw=10,  //10
      TCal      //11
    };
  }

  namespace NEUTRON{
    enum {
      Q=10,     
      T,     
      Betax, 
      Betay, 
      Betaz, 
      Gammax,
      Gammay,
      Gammaz,
      Px,    
      Py,    
      Pz,    
      P,     
      E,     
      Theta, 
      Phi,   
    };
  }
}

#endif
