#ifndef TALNEBULAHPCEXAMPLE_HH
#define TALNEBULAHPCEXAMPLE_HH

#include "TArtAnaLoop.hh"

#include "TArtSAMURAIParameters.hh"
#include "TArtCalibNEBULA.hh"
#include "TArtNEBULAPla.hh"
#include "TArtNEBULAPlaPara.hh"
#include "TArtCalibNEBULAHPC.hh"
#include "TArtNEBULAHPC.hh"
#include "TArtNEBULAHPCPara.hh"

class TAlNEBULAHPCExample : public virtual TArtAnaLoop
{
public:
  TAlNEBULAHPCExample();
  virtual ~TAlNEBULAHPCExample();

protected:
  virtual void Construct();
  virtual void Calculate();
  virtual void Destruct();

  void FillNEBULA();
  void FillNEBULAHPC();

  TArtSAMURAIParameters* samuraiparameters;

  TArtCalibNEBULA *calibnebula;
  TArtCalibNEBULAHPC *calibnebulahpc;

public:
  virtual const char* ClassName() const;

  ClassDef(TAlNEBULAHPCExample,1);
};

#endif
