#ifndef TALSAMURAIPLAEXAMPLE_HH
#define TALSAMURAIPLAEXAMPLE_HH

#include "TArtAnaLoop.hh"

#include "TROOT.h"
#include "TH2.h"
#include "TNtuple.h"

#include "TArtSAMURAIParameters.hh"
#include "TArtCalibSAMURAIPla.hh"

class TAlSAMURAIPlaExample : public virtual TArtAnaLoop
{
public:
  TAlSAMURAIPlaExample();
  virtual ~TAlSAMURAIPlaExample();

protected:
  virtual void Construct();
  virtual void Calculate();
  virtual void Destruct();

  TH1 *hf3pla_tl;
  TH1 *hf3pla_tr;
  TH1 *hf3pla_ql;
  TH1 *hf3pla_qr;

  TH1 *hf7pla_tl;
  TH1 *hf7pla_tr;
  TH1 *hf7pla_ql;
  TH1 *hf7pla_qr;

  TH1 *hf13pla1_tl;
  TH1 *hf13pla1_tr;
  TH1 *hf13pla1_ql;
  TH1 *hf13pla1_qr;

  TH1 *hf13pla2_tl;
  TH1 *hf13pla2_tr;
  TH1 *hf13pla2_ql;
  TH1 *hf13pla2_qr;

  TH1 *hf13sbv_tl;
  TH1 *hf13sbv_tr;
  TH1 *hf13sbv_ql;
  TH1 *hf13sbv_qr;

  TNtuple *ntp;

private:
  TArtSAMURAIParameters* samuraiparameters;
  TArtCalibSAMURAIPla *calibsamuraipla;

public:
  virtual const char* ClassName() const;

  ClassDef(TAlSAMURAIPlaExample,1);
};

#endif
