
#include "TAlSAMURAIAllExample.hh"

#include "TArtAnaLoopManager.hh"
#include "EAnalyser.hh"
#include "EWNum.hh"

TAlSAMURAIAllExample::TAlSAMURAIAllExample()
  : TAlSAMURAICoinExample(),
    TAlNEBULAExample(), TAlDALIExample(),
    TAlSAMURAIPlaExample(), TAlSAMURAIHODExample(),
    TAlSAMURAIDCExample()
{;}

TAlSAMURAIAllExample::TAlSAMURAIAllExample(int nebulaflag)
  : TAlSAMURAICoinExample(),
    TAlNEBULAExample(nebulaflag), TAlDALIExample(),
    TAlSAMURAIPlaExample(), TAlSAMURAIHODExample(),
    TAlSAMURAIDCExample()
{;}

TAlSAMURAIAllExample::TAlSAMURAIAllExample(std::vector<int> analyser_v)
  : TAlSAMURAICoinExample(),
    TAlNEBULAExample(), TAlDALIExample(),
    TAlSAMURAIPlaExample(), TAlSAMURAIHODExample(),
    TAlSAMURAIDCExample()
{
  SetAnalyser(analyser_v);
}

TAlSAMURAIAllExample::TAlSAMURAIAllExample(std::vector<int> analyser_v, int nebulaflag)
  : TAlSAMURAICoinExample(),
    TAlNEBULAExample(nebulaflag), TAlDALIExample(),
    TAlSAMURAIPlaExample(), TAlSAMURAIHODExample(),
    TAlSAMURAIDCExample()
{
  SetAnalyser(analyser_v);
}

TAlSAMURAIAllExample::~TAlSAMURAIAllExample()
{;}

void TAlSAMURAIAllExample::Construct()
{
  if(fAnalyserFlag[Analyser::GLOBAL]) TAlSAMURAICoinExample::Construct();
  if(fAnalyserFlag[Analyser::NEBULA]) TAlNEBULAExample::Construct();
  if(fAnalyserFlag[Analyser::DALI]) TAlDALIExample::Construct();
  if(fAnalyserFlag[Analyser::SAMURAIPLA]) TAlSAMURAIPlaExample::Construct();
  if(fAnalyserFlag[Analyser::SAMURAIHOD]) TAlSAMURAIHODExample::Construct();
  if(fAnalyserFlag[Analyser::SAMURAIDC]) TAlSAMURAIDCExample::Construct();
}

void TAlSAMURAIAllExample::Calculate()
{
  if(fAnalyserFlag[Analyser::GLOBAL]) TAlSAMURAICoinExample::Calculate();
  if(fAnalyserFlag[Analyser::NEBULA]) TAlNEBULAExample::Calculate();
  if(fAnalyserFlag[Analyser::DALI]) TAlDALIExample::Calculate();
  if(fAnalyserFlag[Analyser::SAMURAIPLA]) TAlSAMURAIPlaExample::Calculate();
  if(fAnalyserFlag[Analyser::SAMURAIHOD]) TAlSAMURAIHODExample::Calculate();
  if(fAnalyserFlag[Analyser::SAMURAIDC]) TAlSAMURAIDCExample::Calculate();
}

void TAlSAMURAIAllExample::Destruct()
{
  if(fAnalyserFlag[Analyser::GLOBAL]) TAlSAMURAICoinExample::Destruct();
  if(fAnalyserFlag[Analyser::NEBULA]) TAlNEBULAExample::Destruct();
  if(fAnalyserFlag[Analyser::DALI]) TAlDALIExample::Destruct();
  if(fAnalyserFlag[Analyser::SAMURAIPLA]) TAlSAMURAIPlaExample::Destruct();
  if(fAnalyserFlag[Analyser::SAMURAIHOD]) TAlSAMURAIHODExample::Destruct();
  if(fAnalyserFlag[Analyser::SAMURAIDC]) TAlSAMURAIDCExample::Destruct();
}

void TAlSAMURAIAllExample::SetAnalyser(std::vector<int> analyser_v)
{
  if(analyser_v.empty()){
    for(int i=0; i<TArtValMap::MaxAnalyserSize; ++i) fAnalyserFlag[i] = true;
  }else{
    for(int i=0; i<TArtValMap::MaxAnalyserSize; ++i) fAnalyserFlag[i] = false;    
    SetAnalyserFlag(analyser_v, Analyser::GLOBAL);
    SetAnalyserFlag(analyser_v, Analyser::NEBULA);
    SetAnalyserFlag(analyser_v, Analyser::DALI);       
    SetAnalyserFlag(analyser_v, Analyser::SAMURAIPLA);
    SetAnalyserFlag(analyser_v, Analyser::SAMURAIHOD);
    SetAnalyserFlag(analyser_v, Analyser::SAMURAIDC);
  }
}

const char* TAlSAMURAIAllExample::ClassName() const
{
  return "TAlSAMURAIAllExample";
}
