#ifndef _TARTDALINAI_H_
#define _TARTDALINAI_H_

#include "TArtDataObject.hh"

class TArtDALINaI: public TArtDataObject {

 public:

 TArtDALINaI()
   : TArtDataObject(), fADC(0), fTDC(0), layer(-1), theta(-1), costheta(-1),
    fEnergy(-1), fDoppCorEnergy(-1), fTime(-1), fTimeOffseted(-1)
    {;}
  virtual ~TArtDALINaI(){}

  virtual void SetLayer(int val){layer = val;}
  virtual void SetTheta(Double_t val){theta = val;}

  virtual int  GetLayer(){return layer;}
  virtual Double_t  GetTheta(){return theta;}

  // function to set raw data
  virtual void  SetRawADC(unsigned int val){fADC = val;}
  virtual void  SetRawTDC(unsigned int val){fTDC = val;}
  //virtual void  SetRawTRef(unsigned int val){fTRef = val;}

  // function to get raw data
  virtual unsigned int GetRawADC(){return fADC;}
  virtual unsigned int GetRawTDC(){return fTDC;}
  //virtual unsigned int GetRawTRef(){return fTRef;}

  // function to set reco data
  virtual void  SetCosTheta(Double_t val){costheta = val;}
  virtual void  SetEnergy(Double_t val){fEnergy = val;}
  virtual void  SetDoppCorEnergy(Double_t val){fDoppCorEnergy = val;}
  virtual void  SetTime(Double_t val){fTime = val;}
  virtual void  SetTimeOffseted(Double_t val){fTimeOffseted = val;}
  virtual void  SetTimeTrueEnergy(Double_t val){fTimeTrueEnergy = val;}
  virtual void  SetTimeTrueDoppCorEnergy(Double_t val){fTimeTrueDoppCorEnergy = val;}
  virtual void  SetTimeTrueTime(Double_t val){fTimeTrueTime = val;}
  virtual void  SetTimeTrueTimeOffseted(Double_t val){fTimeTrueTimeOffseted = val;}

  // function to get reco data
  virtual Double_t GetCosTheta(){return costheta;}
  virtual Double_t GetEnergy(){return fEnergy;}
  virtual Double_t GetDoppCorEnergy(){return fDoppCorEnergy;}
  virtual Double_t GetTime(){return fTime;}
  virtual Double_t GetTimeOffseted(){return fTimeOffseted;}
  virtual Double_t GetTimeTrueEnergy(){return fTimeTrueEnergy;}
  virtual Double_t GetTimeTrueDoppCorEnergy(){return fTimeTrueDoppCorEnergy;}
  virtual Double_t GetTimeTrueTime(){return fTimeTrueTime;}
  virtual Double_t GetTimeTrueTimeOffseted(){return fTimeTrueTimeOffseted;}

 private:

  unsigned int fADC;  
  unsigned int fTDC;  
  //unsigned int fTRef;  

  int layer;  
  Double_t theta; // angle w.r.t. target

  Double_t costheta; // cos angle of nai
  Double_t fEnergy;  
  Double_t fDoppCorEnergy;  
  Double_t fTime;  
  Double_t fTimeOffseted;
  Double_t fTimeTrueEnergy;
  Double_t fTimeTrueDoppCorEnergy;
  Double_t fTimeTrueTime;
  Double_t fTimeTrueTimeOffseted;


  ClassDef(TArtDALINaI,1);

};
#endif
