#ifndef _TARTSISTOPPER_H_
#define _TARTSISTOPPER_H_

#include "TArtDataObject.hh"

class TArtSiStopper: public TArtDataObject {

 public:
 TArtSiStopper() : fHGADC(99999), fLGADC(99999), fTDC(9999999), locallayer(-1), layer(-1), localchannel(-1), fLGEnergy(-1), fHGEnergy(-1), fTime(-1) {}
  virtual ~TArtSiStopper(){}

  virtual void SetLocalChannel(int val){localchannel = val;}
  virtual int  GetLocalChannel(){return localchannel;}
  virtual void SetLocalLayer(int val){locallayer = val;}
  virtual int  GetLocalLayer(){return locallayer;}
  virtual void SetLayer(int val){layer = val;}
  virtual int  GetLayer(){return layer;}

  // function to set raw data
  virtual void  SetRawHGADC(int val){fHGADC = val;}
  virtual void  SetRawLGADC(int val){fLGADC = val;}
  virtual void  SetRawTDC(int val){fTDC = val;}

  // function to get raw data
  virtual unsigned int GetRawHGADC(){return fHGADC;}
  virtual unsigned int GetRawLGADC(){return fLGADC;}
  virtual unsigned int GetRawTDC(){return fTDC;}

  // function to set reco data
  virtual void  SetHGEnergy(Double_t val){fHGEnergy = val;}
  virtual void  SetLGEnergy(Double_t val){fLGEnergy = val;}
  virtual void  SetTime(Double_t val){fTime = val;}

  // function to get reco data
  virtual Double_t GetHGEnergy(){return fHGEnergy;}
  virtual Double_t GetLGEnergy(){return fLGEnergy;}
  virtual Double_t GetTime(){return fTime;}

 private:

  // raw value
  unsigned int fHGADC;   // high gain adc, i.e. beta 
  unsigned int fLGADC;   // low gain adc, i.e. hi
  unsigned int fTDC;  

  int locallayer;  
  int layer;  
  int localchannel;  

  // calibrated value
  Double_t fLGEnergy;  
  Double_t fHGEnergy;  
  Double_t fTime;  


  ClassDef(TArtSiStopper,1)

};

ClassImp(TArtSiStopper)

#endif
