#ifndef _TARTSISTOPPERCHAIN_H_
#define _TARTSISTOPPERCHAIN_H_

#include "TArtDataObject.hh"

class TArtSiStopperChain: public TArtDataObject {

 public:
 TArtSiStopperChain() : layer(-1){for(int i=0;i<2;i++){fADC[i]=99999;channel[i]=-1;fEnergy[i] = -1;}}
  virtual ~TArtSiStopperChain(){}

  virtual void SetLayer(int val){layer = val;}
  virtual int  GetLayer(){return layer;}
  virtual void SetChannel(int i, int val){channel[i] = val;}
  virtual int  GetChannel(int i){return channel[i];}

  // function to set raw data
  virtual void SetRawADC(int i, unsigned int val){fADC[i] = val;}

  // function to get raw data
  virtual unsigned int GetRawADC(int i){return fADC[i];}

  // function to set reco data
  virtual void  SetEnergy(int i, Double_t val){fEnergy[i] = val;}

  // function to get reco data
  virtual Double_t GetEnergy(int i){return fEnergy[i];}

 private:

  // raw value
  unsigned int fADC[2];  

  int layer;  
  int channel[2];  

  // calibrated value
  Double_t fEnergy[2];  

  ClassDef(TArtSiStopperChain,1)

};

ClassImp(TArtSiStopperChain)

#endif
