#ifndef _TARTDCHIT_H_
#define _TARTDCHIT_H_

#include "TArtDataObject.hh"

class TArtDCHit : public TArtDataObject {

 public:
  TArtDCHit(){fTDC=0;fPosition=-9999;}
  virtual ~TArtDCHit(){}

  // function to set raw data
  virtual void  SetTDC(Double_t val){fTDC = val;}
  virtual void  SetRealTDC(unsigned int val){fRealTDC = val;}
  // function to get raw data
  virtual Double_t GetTDC(){return fTDC;}
  virtual unsigned int GetRealTDC(){return fRealTDC;}
 
  // set reconstructed values
  virtual void SetPosition(Double_t val){fPosition=val;} // position w.r.t. wire
  // get reconstructed values
  virtual Double_t GetPosition(){return fPosition;}

  virtual void SetWireDirection(char *val) { anodedir=val; }
  virtual void SetWireDirection(TString str) { anodedir=str; }
  virtual void SetWireID(int val) { wireid=val; }
  virtual void SetWirePosition(Double_t val) { wirepos=val; }
  virtual void SetWireZPosition(Double_t val) { wirez=val; }
  virtual void SetLayer(Int_t val) { layer=val; }
  virtual void SetPlaneID(Int_t val) { id_plane=val; }
  virtual TString *GetWireDirection() { return &anodedir; }
  virtual Int_t GetWireID() { return wireid; }
  virtual Double_t GetWirePosition() const { return wirepos; }
  virtual Double_t GetWireZPosition() const { return wirez; }
  virtual Int_t GetLayer() { return layer; }
  virtual Int_t GetPlaneID() { return id_plane; }

 private:

  // parameters
  int layer; // n-th layer
  int id_plane; // plane id
  TString anodedir; // wire direction 
  Double_t wirepos; // wire-x position
  Double_t wirez; // wire-y position
  int wireid; // wire-id

  // raw data
  unsigned int fRealTDC;
  // raw data w/ offset
  Double_t fTDC;

  // reconstructed data
  Double_t fPosition;

 public:
  // overriding functions for sorting based on tdc
  Bool_t IsEqual(TObject *obj) const { return fRealTDC == ((TArtDCHit*)obj)->fRealTDC;} 
  Bool_t IsSortable() const { return kTRUE; } 
  Int_t Compare(const TObject *obj) const { 
    if (fRealTDC < ((TArtDCHit*)obj)->fRealTDC) return -1; 
    else if (fRealTDC > ((TArtDCHit*)obj)->fRealTDC) return 1; 
    else return 0; 
  }

  ClassDef(TArtDCHit,1)

};
#endif
