#ifndef _TARTHODPLA_H_
#define _TARTHODPLA_H_

#include "TArtDataObject.hh"

class TArtHODPla : public TArtDataObject {

 public:
  TArtHODPla(){fTURaw=0;fTDRaw=0;fQURaw=0;fQDRaw=0;fTime=-1;fTimeU=-1;fTimeD=-1;fTimeUSlew=-1;fTimeDSlew=-1;fTimeSlew=-1;}
  virtual ~TArtHODPla(){}

  // function to set Q data
  void  SetTURaw(int val){fTURaw = val;}
  void  SetTDRaw(int val){fTDRaw = val;}
  void  SetQURaw(int val){fQURaw = val;}
  void  SetQDRaw(int val){fQDRaw = val;}
  void  SetQUPed(int val){fQUPed = val;} 
  void  SetQDPed(int val){fQDPed = val;} 
  void  SetQUCal(int val){fQUCal = val;}
  void  SetQDCal(int val){fQDCal = val;}
  void  SetQAveRaw(Double_t val){fQAveRaw = val;}
  void  SetQAvePed(Double_t val){fQAvePed = val;}
  void  SetQAveCal(Double_t val){fQAveCal = val;}

  // function to get Q data
  unsigned int GetTURaw(){return fTURaw;}
  unsigned int GetTDRaw(){return fTDRaw;}
  unsigned int GetQURaw(){return fQURaw;}
  unsigned int GetQDRaw(){return fQDRaw;}
  Double_t GetQUPed(){return fQUPed;} 
  Double_t GetQDPed(){return fQDPed;} 
  Double_t GetQUCal(){return fQUCal;}
  Double_t GetQDCal(){return fQDCal;}
  Double_t GetQAveRaw(){return fQAveRaw;}
  Double_t GetQAvePed(){return fQAvePed;}
  Double_t GetQAveCal(){return fQAveCal;}
 
  // get reconstructed values
  virtual void SetTime(Double_t val){fTime=val;}
  virtual void SetTimeU(Double_t val){fTimeU=val;}
  virtual void SetTimeD(Double_t val){fTimeD=val;}
  virtual void SetTimeUSlew(Double_t val){fTimeUSlew=val;}
  virtual void SetTimeDSlew(Double_t val){fTimeDSlew=val;}
  virtual void SetTimeSlew (Double_t val){fTimeSlew=val;}

  // get reconstructed values
  Double_t GetTime(){return fTime;}
  Double_t GetTimeU(){return fTimeU;}
  Double_t GetTimeD(){return fTimeD;}
  Double_t GetTimeUSlew(){return fTimeUSlew;}
  Double_t GetTimeDSlew(){return fTimeDSlew;}
  Double_t GetTimeSlew (){return fTimeSlew;}

 private:

  // Q data
  unsigned int fTURaw;  
  unsigned int fTDRaw;
  unsigned int fQURaw;  
  unsigned int fQDRaw;
  Double_t     fQUPed;
  Double_t     fQDPed;
  Double_t     fQUCal;
  Double_t     fQDCal;
  Double_t     fQAveRaw;
  Double_t     fQAvePed;
  Double_t     fQAveCal;

  // reconstructed data
  Double_t   fTime;
  Double_t   fTimeU;
  Double_t   fTimeD;
  Double_t   fTimeUSlew; // after slewing correction
  Double_t   fTimeDSlew;
  Double_t   fTimeSlew;


  ClassDef(TArtHODPla,1);

};
#endif
