#include "TArtRecoFragment.hh" 
#include "TArtFragment.hh"

#include "TArtCore.hh" 
#include "TArtStoreManager.hh"

#include <TClonesArray.h>

//__________________________________________________________
TArtRecoFragment::TArtRecoFragment()
{
  TArtCore::Info(__FILE__,"Creating the Reco Fragment objects...");
  sman = TArtStoreManager::Instance();

  fFragmentArray = new TClonesArray("TArtFragment",4);
  fFragmentArray->SetName("SAMURAIFragment");
  fFragmentArray->SetOwner();
  sman->AddDataContainer(fFragmentArray);

}

//__________________________________________________________
TArtRecoFragment::~TArtRecoFragment()  {
  ClearData();
}

//__________________________________________________________
void TArtRecoFragment::ClearData()   {
  fFragmentArray->Clear();
  fReconstructed = false;
  return;
}

//__________________________________________________________
void TArtRecoFragment::ReconstructData() { 
  fReconstructed = true;
  return;
}

ClassImp(TArtRecoFragment)
